/*
 * SSE2030_P03.c
 *
 *  SSE2030: Introduction to Computer Systems (Fall 2014)
 *  Skeleton code for PA#3
 *
 *   Created on: Oct 10, 2014
 *       Author: DongHyun, Song
 * Organization: Sungkyunkwan University - Computer Systems Laboratory
 */



#include "mp_sort.h"

void
err_message(int err_code)
{
	switch (err_code)
	{
		case -1:
		{
			printf("There is no input/output file...\n");
			break;
		}
		case -2:
		{
			printf("Job is not allowed...\n");
			break;
		}
		default:
		{
			break;
		}
	}
}

int main(int argc, char** argv)
{
	char* input_path = NULL;
	char* output_path = NULL;
	char* buffer = NULL;
	int buf_size = 0;
	int n = 0;
	int err;

	if (argc > 4)
	{
		input_path = argv[1];
		output_path = argv[2];
		buf_size = atoi(argv[3]);
		n = atoi(argv[4]);

		buffer = (char*)malloc(buf_size);
		if (!buffer)
		{
			printf("'buffer' malloc() is failed...\n");
			return EXIT_FAILURE;
		}
	}

	struct timeval stime;
	struct timeval etime;
	gettimeofday(&stime, NULL);
	err = mp_sort(input_path, output_path, buffer, buf_size, n);
	gettimeofday(&etime, NULL);

	if (argc > 7 && argv[7] != NULL)
	{
		snprintf(buffer, 512, "rm -f %s", output_path);
		system(buffer);

		printf("%ld\n", (etime.tv_sec - stime.tv_sec));
		return 0;
	}

	if (err == 0)
	{
		char scommand[512] = {0,};

		if (argc > 6 && argv[6] != NULL) // server
		{
			int fh, n, read_sum = 0;
			snprintf(scommand, 512, "diff -q -s %s %s > %s", argv[5], output_path, argv[6]);
			system(scommand);
	
			fh = open(argv[6], O_RDONLY);
			while ((n = read(fh, buffer+read_sum, buf_size-read_sum)) > 0)
			{
				read_sum += n;
			}
			buffer[read_sum] = '\0';
			printf("%s", buffer);
			close(fh);	
	
			snprintf(buffer, 512, "rm -f %s %s", output_path, argv[6]);
			system(buffer);
		}
		else // local
		{ 
			if (output_path)
			{
				snprintf(scommand, 512, "diff -q -s correct_output.dat %s", output_path);
				system(scommand);
			}
		}
	}
	else
	{
		err_message(err);
	}

	if (buffer)
	{
		free(buffer);
	}

	return 0;
}
